----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    21:17:50 04/19/2014 
-- Design Name: 
-- Module Name:    filter - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_SIGNED.ALL;
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity filter is
    Port ( CLKLeft 	: in  STD_LOGIC;
			  CLKRight 	: in  STD_LOGIC;
           InLeft 	: in  STD_LOGIC_VECTOR (23 downto 0);
           InRIght 	: in  STD_LOGIC_VECTOR (23 downto 0);
           OutLeft 	: out STD_LOGIC_VECTOR (23 downto 0);
           OutRight 	: out STD_LOGIC_VECTOR (23 downto 0);
           CTL 		: in  STD_LOGIC
			);
end filter;

architecture Behavioral of filter is

signal LeftCnt  : STD_LOGIC := '0';
signal RightCnt : STD_LOGIC := '0';

begin

filterLeft: process (CLKLeft) is
   begin
   
	--ATT: CLK starts just after RST !!
	if(CLKLeft'event and ClkLeft = '1') then
	
		if (CTL = '1') then
			OutLeft <= InLeft;
		else
			if (LeftCnt = '1') then
				OutLeft <= InLeft;
			else
				OutLeft <= STD_LOGIC_VECTOR(SIGNED(InLeft) - (SIGNED(InRight) /2 ));
			end if;
		end if;
		LeftCnt <= not LeftCnt;
	end if;

end process;

filterRight: process (CLKRight) is
   begin

	--ATT: CLK starts just after RST !!
	if(CLKRight'event and ClkRight = '1') then
	
		if (CTL = '1') then
			OutRight <= InRight;
		else
			if (RightCnt = '1') then
				OutRight <= InRight;
			else
				OutRight <= STD_LOGIC_VECTOR(SIGNED(InRight) - (SIGNED(InLeft) /2 ));
			end if;
		end if;
		RightCnt <= not RightCnt;
	end if;

end process;

end Behavioral;

