----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    21:26:12 05/05/2014 
-- Design Name: 
-- Module Name:    rotary - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
Use IEEE.Std_Logic_unsigned.all;
Use IEEE.numeric_std.all;
Use IEEE.std_logic_arith.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity rotary is
    Port ( CLK 		: in  STD_LOGIC;
           A 			: in  STD_LOGIC;
           B 			: in  STD_LOGIC;
			  value		: out std_logic_vector(6 downto 0) --7 bit value out
			);
end rotary;

architecture Behavioral of rotary is

signal A_INT 	: std_logic := '0';
signal B_INT 	: std_logic := '0';
signal A_INT_P : std_logic := '0';
signal B_INT_P : std_logic := '0';
--signal count : std_logic_vector(6 downto 0):="0111111?;
signal count 	: integer range 0 to 127 := 0;

begin

ROTARY_SAMPLE: process (Clk, count) begin
	
	value <= conv_std_logic_vector(count, 7);
	
	if rising_edge(Clk) then
	
		A_INT_p <= A_INT;
		B_INT_p <= B_INT;
		A_INT <= A;
		B_INT <= B;

		if (A_INT = '1' and A_INT_P = '0') then		-- A rising
			if (B='0' and count /= 127) then 			-- INC
				count <= count + 1;
			elsif (B='1' and count /= 0) then 			-- DEC
				count <= count - 1;
			end if;
		elsif (B_INT = '1' and B_INT_P = '0') then 	-- B rising
			if (A='1' and count /= 127) then 			-- INC
				count <= count + 1;
			elsif (A='0' and count /= 0) then 			-- DEC
				count <= count - 1;
			end if;
		elsif (A_INT = '0' and A_INT_P = '1') then 	-- A falling
			if (B='1' and count /= 127) then 			-- INC
				count <= count + 1;
			elsif (B='0' and count /= 0) then 			-- DEC
				count <= count - 1;
			end if;
		elsif (B_INT = '0' and B_INT_P = '1') then 	-- B falling
			if (A='0' and count /= 127) then 			-- INC
				count <= count + 1;
			elsif (A='1' and count /= 0) then 			-- DEC
				count <= count - 1;
		end if;
		else
			count <= count;
		end if;
		
	end if;

end process;
	
end Behavioral;

