--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   23:09:15 03/24/2014
-- Design Name:   
-- Module Name:   D:/My_Documents/Xilinx_ISE_Projects/CmodS6/top_bench.vhd
-- Project Name:  CmodS6
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: i2s_top
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY top_bench IS
END top_bench;
 
ARCHITECTURE behavior OF top_bench IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT i2s_top
    PORT(
			CLK			: IN  std_Logic;
			RST			: IN  std_logic;
         I2S_DATA_I 	: IN  std_logic;
         I2S_LRCK_I 	: IN  std_logic;
         I2S_BCK_I 	: IN  std_logic;
         I2S_DATA_O 	: OUT std_logic;
         I2S_LRCK_O 	: OUT std_logic;
         I2S_BCK_O 	: OUT std_logic;
			CTRL			: in  std_logic
        );
    END COMPONENT;
    

   --Inputs
	signal CLK			: std_logic := '0';
   signal I2S_DATA_I : std_logic := '0';
   signal I2S_LRCK_I : std_logic := '0';
   signal I2S_BCK_I 	: std_logic := '0';

 	--Outputs
   signal I2S_DATA_O : std_logic;
   signal I2S_LRCK_O : std_logic;
   signal I2S_BCK_O 	: std_logic;
   -- No clocks detected in port list. Replace <clock> below with 
   -- appropriate port name 
 
   constant I2S_BCK_period : time := 40 ns;
	constant EXT_CLK_period : time :=  5 ns;
	
	signal delayRelease : std_logic := '0';
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: i2s_top PORT MAP (
			 CLK			=> CLK,
			 RST			=> '0',
          I2S_DATA_I => I2S_DATA_I,
          I2S_LRCK_I => I2S_LRCK_I,
          I2S_BCK_I 	=> I2S_BCK_I,
          I2S_DATA_O => I2S_DATA_O,
          I2S_LRCK_O => I2S_LRCK_O,
          I2S_BCK_O 	=> I2S_BCK_O,
			 CTRL			=> '1'
        );

   -- Clock process definitions
   I2S_BCK_process :process
   begin
		I2S_BCK_I <= '0';
		wait for I2S_BCK_period/2;
		I2S_BCK_I <= '1';
		wait for I2S_BCK_period/2;
   end process;
 
   EXT_CLK_process :process
   begin
	   if (delayRelease = '0') then
			--wait for 37 ns;
			delayRelease <= '1';
		end if;
		
		CLK <= '0';
		wait for EXT_CLK_period/2;
		CLK <= '1';
		wait for EXT_CLK_period/2;
   end process;
	
   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100 ns.
		I2S_LRCK_I <= '1';
		I2S_DATA_I <= '0';
      wait for 120 ns;	

      -- insert stimulus here 
		
      wait for I2S_BCK_period;
		
		I2S_LRCK_I <= '0';
		wait for I2S_BCK_period;
		
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		I2S_LRCK_I <= '1';
		wait for I2S_BCK_period;		
		I2S_DATA_I <= '0';
		
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		I2S_LRCK_I <= '0';
		wait for I2S_BCK_period;	
		
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		I2S_LRCK_I <= '1';
		wait for I2S_BCK_period;	
		
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		I2S_LRCK_I <= '0';
		wait for I2S_BCK_period;			

		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		I2S_LRCK_I <= '1';
		wait for I2S_BCK_period;	

		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		I2S_LRCK_I <= '0';
		wait for I2S_BCK_period;	
		
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		I2S_LRCK_I <= '1';
		wait for I2S_BCK_period;	

		loop
		
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		I2S_LRCK_I <= '0';
		wait for I2S_BCK_period;	
		
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '1';
		wait for I2S_BCK_period;
		I2S_DATA_I <= '0';
		I2S_LRCK_I <= '1';
		wait for I2S_BCK_period;	
		
		end loop;
		
   end process;

END;
